// @HEADER
// @HEADER

#ifndef XPETRA_DOXYGEN_DOCUMENTATION_HPP
#define XPETRA_DOXYGEN_DOCUMENTATION_HPP

/*!

\mainpage

@image html xpetra.jpg

\section main_index Table of Contents

- \ref xpetra_overview
- \ref xpetra_packagesUsingXpetra
- \ref xpetra_authors
- \ref xpetra_copyright
- \ref xpetra_questions

\section xpetra_overview Overview


Xpetra a lightweight wrapper to both Epetra and Tpetra.  The Xpetra syntax mirrors that of Tpetra.  Xpetra enables
algorithm developers to write to a single interface but be able to use either Epetra or Tpetra.
Xpetra can also be introduced into existing code to allow for gradual migration.

\section xpetra_packagesUsingXpetra Packages Currently Using Xpetra
Xpetra is used by the MueLu and Zoltan2 projects.

\section xpetra_authors Authors and Contributors

  - Jeremie Gaidamour, Sandia National Labs
  - Axel Gerstenberger, Sandia National Labs
  - Jonathan Hu, Sandia National Labs
  - Andrey Prokopenko, Sandia National Labs
  - Chris Siefert, Sandia National Labs
  - Ray Tuminaro, Sandia National Labs
  - Tobias Wiesner, Technical University Munich

\section xpetra_copyright Copyright and License

\verbinclude COPYRIGHT_AND_LICENSE

\section xpetra_questions For All Questions and Comments...

   Please contact Jonathan Hu (jhu@sandia.gov) or Andrey Prokopenko (aprokop@sandia.gov).

*/

/* ************************************************************************ */
/* ************************************************************************ */

/*! \page user_guide Users Guide

\section user_guide_index Index

- \ref user_guide_getting_started
- \ref questions

\section user_guide_getting_started Getting Started

*/

/* ************************************************************************ */
/* ************************************************************************ */

/*! \page todo ToDo List

Short Term:
<ul>
<li> ???
</ul>

Long Term:
<ul>
<li> ???
<li>
</ul>

*/

/* ************************************************************************ */
/* ************************************************************************ */

/*! \page faq Frequently Asked Questions

\section Questions
\ref faq1

\ref faq2

\section faq1 1. Why name the code Xpetra?
Why not?

\section faq2 2. Put your question here?
Answer your question here.

*/

/* ************************************************************************ */
/* ************************************************************************ */

#endif //ifndef XPETRA_DOXYGEN_DOCUMENTATION_HPP
